/********************************************************************* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Peter Jiawei Liang
 * Student ID: 9825319
 * Section:    AJ
 * E-mail:	   pdeportist@aol.com		
 * 
 ********************************************************************/

#include "gp142.h"
#include <math.h>
#include <time.h>
	
#define TRUE    		1
#define FALSE   		0

#define STATUS_ADD_SHAPE 1
#define STATUS_SELECTED 2
#define STATUS_OBJECT 3
#define STATUS_MESSAGE 4

#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100
#define SELECT_OBJECT_RANGE	30

#define NUM_BUTTONS 	8
#define SELECTED_COLOR  RED

#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

#define FILL 0
#define NOFILL 1
#define JUNK -1

#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

#define MAX_NUM_SHAPES	100	/* maxinum number of shapes allowed on card	*/
#define MAX_MESSAGE 5
#define FIRST_MESSAGE_NUM 0
#define MAX_SHAPES 5
#define FIRST_SHAPE_NUM 0
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_SMILE  2
#define SHAPE_ROSE  3
#define SHAPE_DORA  4
#define MESSAGE1 0
#define MESSAGE2 1
#define MESSAGE3 2
#define MESSAGE4 3
#define MESSAGE5 4
#define MESSAGE_FONT 10

#define HEART_WIDTH 35		/* shapes' sizes	*/
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
#define SMILERADIUS 20
#define EYERADIUS 4
#define ROSESIZE 10

#define CLICK_BUTTON 1  
#define CLICK_CARD 2    
#define CLICK_OUTSIDE 3	

/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status);
void DrawSky(void);							/* Draw sky				*/
void DrawStuff(int color, int shape_type, int message_type, 
			   int bottom_x, int bottom_y); /* Draw shape or message*/
void DrawHeart (int x, int y, int color);	/* Draw heart			*/
void DrawStar (int x, int y, int color);	/* Draw star			*/
void DrawSmile (int x, int y, int color);	/* Draw smilie face		*/
void DrawRose (int x, int y, int color);	/* Draw rose			*/
void DrawDora (int x, int y);				/* Draw Doraemon		*/

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int *object_type, 
					  int *object_num, int *message_num, int *object_color, 
					  int *object_x, int *object_y, int object_NUM[], 
					  int message_NUM[], int object_COLOR[], int object_X[], 
					  int object_Y[], int object_TYPE[], int *last_button, 
					  int *sky);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type, int *object_num, 
				  int *message_num, int *object_color, int *last_button, 
				  int *sky);
void AddStuff(int x, int y, int *status, int *object_count, int *object_type, 
			  int *object_num, int *message_num, int *object_color, 
			  int *object_x, int *object_y);/* Add shape or message	*/

/*****************************************************************************

     MAIN

*****************************************************************************/

int main(void)
{
	int i;					/* use in for loop to print all current shapes	*/
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	int sky = FALSE;				/* if true, then draws sky			*/
	
	int object_count = 0;           /* How many objects on the page?	*/
	int object_type = OBJECT_NONE;  /* Can also be a shape or message	*/
	int object_num;                 /* shape type						*/
	int message_num;				/* message type						*/
	int object_color;               /* Color of object					*/
	int object_x;                   /* Position of object				*/
	int object_y;
	int object_NUM[MAX_NUM_SHAPES], object_COLOR[MAX_NUM_SHAPES],
		object_X[MAX_NUM_SHAPES], object_Y[MAX_NUM_SHAPES],
		message_NUM[MAX_NUM_SHAPES], object_TYPE[MAX_NUM_SHAPES];
									/* arrays for objects				*/
	int last_button = -1;           
	int event; /*the most recent GP142 event*/
	time_t t; /*needed only when initializing a random number generator*/
	
	srand (time(&t));	    

	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
		
	/*	The main event loop	 */

	while (!quit) 
	{
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status);
		if(sky == TRUE)
			DrawSky();
		DrawButtons(last_button);	  /* Show the buttons...*/ 
		
		/*	redraw all current shapes or messages	*/
		if(object_count == -1) {}	/* do nothing if screen is cleared */
		else
		{
			for(i = 0; i < object_count; i++)
			{
				DrawStuff (object_COLOR[i], object_NUM[i], message_NUM[i], 
					object_X[i], object_Y[i]);
			}
			if(!(status == STATUS_ADD_SHAPE || status == STATUS_MESSAGE))
				DrawStuff (object_COLOR[i], object_NUM[i], message_NUM[i],
					object_X[i], object_Y[i]);
		}	
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) 
		{
			case GP142_QUIT:
				quit = TRUE;    
				break;
			case GP142_KBD: 
				break;
			case GP142_MOUSE:
				HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					&object_count, &object_type, &object_num, &message_num,
					&object_color, &object_x, &object_y, object_NUM, message_NUM, 
					object_COLOR, object_X, object_Y, object_TYPE, &last_button, 
					&sky);
				
				if(object_count == -1 || object_count > MAX_NUM_SHAPES) {}
				/* do nothing if screen is cleared or too many objects)	*/
				else if(status == STATUS_ADD_SHAPE || status == STATUS_MESSAGE)
				{
					object_X[object_count - 1] = object_x;
					object_Y[object_count - 1] = object_y;
					object_NUM[object_count - 1] = object_num;
					message_NUM[object_count - 1] = message_num;
					object_COLOR[object_count - 1] = object_color;
					object_TYPE[object_count - 1] = object_type;
				}
				else
				{
					object_X[object_count] = object_x;
					object_Y[object_count] = object_y;
					object_NUM[object_count] = object_num;
					message_NUM[object_count] = message_num;
					object_COLOR[object_count] = object_color;
					object_TYPE[object_count] = object_type;
				}
				break;			
			case GP142_PERIODIC:
				break;
			default:
				break;			
		}  /*end switch */
	}  /* end event loop */
	
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/

void DrawBlankScreen (void) 
{
	int font_size = 14;

	GP142_rectangleXY (WHITE, -GP142_XMAX, -GP142_YMAX,	GP142_XMAX, GP142_YMAX,	FILL);
} 

void DrawButtons(int last_button)
{
	char b_labels[NUM_BUTTONS][25] = {"Background color", "Object color", 
		"Next, please", "Add message", "Add shape", "Select object", "Sky", 
		"Clear screen"};	
	int i, text_offset = -GP142_XMAX + 6, font_size = 12;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) 
	{
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK, -GP142_XMAX + 4, y - 2, -GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, 1);
				
		label_y = y - BUTTON_HEIGHT/2;
		
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}

void DrawCard (int background_color, int status)
{
	int font_size = 14;
	
	GP142_rectangleXY (background_color, PAGE_LLX, PAGE_LLY, PAGE_LLX+ PAGE_WIDTH, 
		PAGE_LLY+ PAGE_HEIGHT, FILL);
	GP142_printfXY (SELECTED_COLOR, PAGE_LLX - 50, PAGE_LLY + PAGE_HEIGHT + 10, 
		font_size + 10,	"Your Personal Greeting Card Designer");
	
	switch (status) 
	{
		case STATUS_ADD_SHAPE:
			GP142_printfXY (MAGENTA, PAGE_LLX-50, PAGE_LLY-40, font_size,
				"Click on the card to add a shape.");
			break;
		case STATUS_SELECTED:
			GP142_printfXY (RED, PAGE_LLX-50, PAGE_LLY-40, font_size,
				"Object selected. Click button to change shape or color.");
			break;
		case STATUS_OBJECT:
			GP142_printfXY (GREEN, PAGE_LLX-50, PAGE_LLY-40, font_size,
				"To select an object, click close to its origin.");
			break;
		case STATUS_MESSAGE:
			GP142_printfXY (PEACH, PAGE_LLX-50, PAGE_LLY-40, font_size,
				"Click on the card to add a message.");
			break;
		default:
			break;
	}
} 

void DrawSky (void)
{
	int num1, num2, num3, num4, num5; /* random numbers	*/
	num1 = rand () % 10;
	num2 = rand () % 10;
	num3 = rand () % 10;
	num4 = rand () % 10;
	num5 = rand () % 10;
	GP142_rectangleXY (ICE_BLUE, PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT, FILL);
	GP142_ovalXY (WHITE, 100 + num1, 105, 150 + num1, 105, 20);
	GP142_ovalXY (WHITE, 110 + num1, 100, 160 + num1, 100, 20);
	GP142_ovalXY (WHITE, -110 + num2, 120, -60 + num2, 120, 20);
	GP142_ovalXY (WHITE, -120 + num2, 125, -70 + num2, 125, 20);
	GP142_ovalXY (WHITE, num3, 150, 50 + num3, 150, 20);
	GP142_ovalXY (WHITE, 10 + num3, 150, 60 + num3, 150, 20);
	GP142_ovalXY (WHITE, -50 + num4, 60, num4, 60, 20);
	GP142_ovalXY (WHITE, -40 + num4, 65, 10 + num4, 65, 20);
	GP142_ovalXY (WHITE, 70 + num5, 80, 120 + num5, 80, 20);
	GP142_ovalXY (WHITE, 60 + num5, 80, 110 + num5, 80, 20);
}

void DrawStuff(int color, int shape_type, int message_type, 
			   int bottom_x, int bottom_y) 
{
	int font;

	font = MESSAGE_FONT + (rand () %5);
	if(shape_type == JUNK)
	{
		switch ((message_type - FIRST_MESSAGE_NUM) % MAX_MESSAGE)
		{
			case MESSAGE1:
				GP142_printfXY (color, bottom_x, bottom_y, font,
					"Be the love of my life.");
				break;
			case MESSAGE2:
				GP142_printfXY (color, bottom_x, bottom_y, font,
					"Love you always.");
				break;
			case MESSAGE3:
				GP142_printfXY (color, bottom_x, bottom_y, font,
					"You are the sunshine in my universe.");
				break;
			case MESSAGE4:
				GP142_printfXY (color, bottom_x, bottom_y, font,
					"I can love you better.");
				break;
			case MESSAGE5:
				GP142_printfXY (color, bottom_x, bottom_y, font,
					"You are the reason I live.");
				break;
			default:
				break;
		}
	}
	else
	{
		switch ((shape_type - FIRST_SHAPE_NUM) % MAX_SHAPES) 
		{
			case SHAPE_HEART:
				DrawHeart (bottom_x, bottom_y, color);
				break;
			case SHAPE_STAR:
				DrawStar (bottom_x, bottom_y, color);
				break;
			case SHAPE_SMILE:
				DrawSmile (bottom_x, bottom_y, color);
				break;
			case SHAPE_ROSE:
				DrawRose (bottom_x, bottom_y, color);
				break;
			case SHAPE_DORA:
				DrawDora (bottom_x, bottom_y);
				break;
			default:
				break;
		}
	}
}

void DrawHeart (int x, int y, int color) 
{
	int h = (HEART_WIDTH/2) + (rand () %4);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5, x + h*2 -5, y-5, x, y - h*2 -5, FILL);
}

void DrawStar (int x, int y, int color)
{
	int sp, x1, y1;
	double angle;
	
	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) 
	{
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);
	}
}


void DrawSmile (int x, int y, int color)
{
	int x1, y1, mouth;
	mouth = rand () % 3;
	x1 = rand () % 3;
	y1 = rand () % 3;
	GP142_circleXY (color, x, y, SMILERADIUS);
	GP142_circleXY (color + 1, x - SMILERADIUS / 5 - 1 + x1, 
		y + SMILERADIUS / 5 - 1 + y1, EYERADIUS);
	GP142_circleXY (color + 1, x + SMILERADIUS / 5 - 1 + x1, 
		y + SMILERADIUS / 5 - 1 + y1, EYERADIUS);
	GP142_triangleXY (color + 1, x - SMILERADIUS / 3, y - SMILERADIUS / 3, 
		x + SMILERADIUS / 3, y - SMILERADIUS / 3, x, 
		y - SMILERADIUS / 3 - mouth * 2, NOFILL);
}


void DrawRose (int x, int y, int color)
{
	int num;
	num = rand () % 3;
	GP142_ovalXY (color, x - ROSESIZE, y - ROSESIZE, x - ROSESIZE, y + ROSESIZE, 
		ROSESIZE + num);
	GP142_ovalXY (color, x + ROSESIZE, y - ROSESIZE, x + ROSESIZE, y + ROSESIZE, 
		ROSESIZE + num);
	GP142_ovalXY (color, x - ROSESIZE + ROSESIZE / 5, y + ROSESIZE + ROSESIZE / 5, 
		x + ROSESIZE - ROSESIZE / 5, y + ROSESIZE + ROSESIZE / 5, ROSESIZE + num);
	GP142_ovalXY (color, x - ROSESIZE + ROSESIZE / 5, y - ROSESIZE - ROSESIZE / 5, 
		x + ROSESIZE - ROSESIZE / 5, y - ROSESIZE - ROSESIZE / 5, ROSESIZE + num);
	GP142_rectangleXY (color, x - ROSESIZE, y - ROSESIZE, x + ROSESIZE, 
		y + ROSESIZE, FILL);
	GP142_lineXY (color + 1, x + ROSESIZE / 2, y - ROSESIZE / 2, 
		x + ROSESIZE, y + ROSESIZE / 2, 1);
	GP142_lineXY (color + 1, x - ROSESIZE / 2, y - ROSESIZE / 2, 
		x - ROSESIZE, y + ROSESIZE / 2, 1);
	GP142_lineXY (color + 1, x, y, x, y - ROSESIZE * 6, 3);
	GP142_circleXY (color + 2, x, y + ROSESIZE / 2, ROSESIZE - 3 + num);
	GP142_circleXY (color + 3, x, y + ROSESIZE / 2, ROSESIZE - 7 + num);
	GP142_triangleXY (color + 4, x, y - ROSESIZE * 2, x - ROSESIZE * 2, 
		y - ROSESIZE, x + ROSESIZE * 2, y - ROSESIZE, FILL);
}

void DrawDora (int x, int y)
{
	int num1, num2, num3, num4, num5; /* random numbers	*/

	num1 = rand () % 7;
	num2 = rand () % 7;
	num3 = rand () % 5;
	num4 = rand () % 10;
	num5 = rand () % 10;

	GP142_ovalXY (BROWN, x - 5 + num4, y + 40 + num5, x + 5 + num4, y + 40 + num5, 15);
	GP142_ovalXY (WHITE, x - 3 + num4, y + 40 + num5, x + 3 + num4, y + 40 + num5, 5);
	GP142_ovalXY (LT_GRAY, x - 6 + num3 + num4, y + 35 + num5, 
		x + num3 + num4, y + 35 + num5, 3);
	GP142_ovalXY (LT_GRAY, x - 2 - num3 + num4, y + 45 + num5, 
		x + 4 - num3 + num4, y + 45 + num5, 3);
	GP142_circleXY (LT_GRAY, x + 8 + num4, y + 38 + num3 + num5, 2);
	GP142_circleXY (LT_GRAY, x - 8 + num4, y + 42 - num3 + num5, 2);
	GP142_lineXY (GREEN, x + num4, y + 20 + num5, x + num4, y + 40 + num5, 3);
	GP142_circleXY (BLUE, x + num4, y - 30 + num5, 20);
	GP142_rectangleXY (BLUE, x - 15 + num4, y - 28 + num5, x - 40 + num4, 
		y - 17 + num5, FILL);
	GP142_rectangleXY (BLUE, x + 15 + num4, y - 28 + num5, x + 40 + num4, 
		y - 17 + num5, FILL);
	GP142_rectangleXY (BLUE, x - 5 + num4, y - 65 + num5, x - 16 + num4, 
		y - 40 + num5, FILL);
	GP142_rectangleXY (BLUE, x + 5 + num4, y - 65 + num5, x + 16 + num4, 
		y - 40 + num5, FILL);
	GP142_circleXY (WHITE, x - 40 + num4, y - 22 + num5, 7);
	GP142_circleXY (WHITE, x + 40 + num4, y - 22 + num5, 7);
	GP142_circleXY (WHITE, x - 11 + num4, y - 65 + num5, 8);
	GP142_circleXY (WHITE, x + 11 + num4, y - 65 + num5, 8);
	GP142_circleXY (WHITE, x + num4, y - 28 + num5, 16);
	GP142_ovalXY (BLUE, x - 6 + num4, y + num5, x + 6 + num4, y + num5, 40);
	GP142_ovalXY (WHITE, x - 5 + num4, y - 2 + num5, x + 5 + num4, y - 2 + num5, 30);
	GP142_circleXY (ORANGE, x - 7 + num4, y + 10 + num5, 7);
	GP142_circleXY (ORANGE, x + 7 + num4, y + 10 + num5, 7);
	GP142_circleXY (BLACK, x - 10 + num1 + num4, y + 7 + num2 + num5, 3); 
	GP142_circleXY (BLACK, x + 4 + num1 + num4, y + 7 + num2 + num5, 3);
	GP142_circleXY (RED, x + num4, y + num5, 5);
	GP142_lineXY (BLACK, x - 4 + num4, y + num5, x - 20 + num4, y + 2 + num5, 1);
	GP142_lineXY (BLACK, x - 4 + num4, y - 2 + num5, x - 20 + num4, y - 2 + num5, 1);
	GP142_lineXY (BLACK, x - 4 + num4, y - 4 + num5, x - 20 + num4, y - 6 + num5, 1);
	GP142_lineXY (BLACK, x + 4 + num4, y + num5, x + 20 + num4, y + 2 + num5, 1);
	GP142_lineXY (BLACK, x + 4 + num4, y - 2 + num5, x + 20 + num4, y - 2 + num5, 1);
	GP142_lineXY (BLACK, x + 4 + num4, y - 4 + num5, x + 20 + num4, y - 6 + num5, 1);
	GP142_triangleXY (RED, x + 10 + num4, y - 8 + num5, x - 10 + num4, y - 8 + num5, 
		x + num4, y - 8 - num3 * 2 + num5, FILL);
	GP142_lineXY (BROWN, x - 10 + num4, y - 20 + num5, x + 10 + num4, y - 20 + num5, 3);
	GP142_circleXY (YELLOW, x + num4, y - 25 + num5, 5);
	GP142_lineXY (BLACK, x - 5 + num4, y - 25 + num5, x + 5 + num4, y - 25 + num5, 1);
	GP142_lineXY (BLACK, x + num4, y - 25 + num5, x + num4, y - 30 + num5, 1);
	GP142_ovalXY (PURPLE, x + 2 + num4, y - 38 + num5, x - 2 + num4, y - 38 + num5, 10);
	GP142_rectangleXY (WHITE, x + 12 + num4, y - 36 + num5, x -12 + num4, 
		y - 30 + num5, FILL);
}

int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
	if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) && (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
		return CLICK_BUTTON;
	else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
		  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
		return CLICK_CARD;
	else
		return CLICK_OUTSIDE;
}

void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, int *status,
					  int *object_count, int *object_type, int *object_num, 
					  int *message_num, int *object_color, int *object_x, int *object_y,
					  int object_NUM[], int message_NUM[], int object_COLOR[], 
					  int object_X[], int object_Y[], int object_TYPE[], 
					  int *last_button, int *sky)
{
	int mouse_click, i;

	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == CLICK_BUTTON) 
	{
		HandleButton(mouse_x, mouse_y, background_color, status, object_count,
			*object_type, object_num, message_num, object_color, last_button, sky);
	} 
	else if (mouse_click == CLICK_CARD) 
	{
		if(*status == STATUS_OBJECT)	/* swap objects when it's selected	*/
		{
			for(i = *object_count; i >= 0; i--)
			{
				if((mouse_x > object_X[i] - SELECT_OBJECT_RANGE)
					&& (mouse_x < object_X[i] + SELECT_OBJECT_RANGE)
					&& (mouse_y > object_Y[i] - SELECT_OBJECT_RANGE)
					&& (mouse_y < object_Y[i] + SELECT_OBJECT_RANGE))
				{
					*object_x = object_X[i];
					*object_y = object_Y[i];
					*object_num = object_NUM[i];
					*message_num = message_NUM[i];
					*object_color = object_COLOR[i];
					*object_type = object_TYPE[i];
					object_X[i] = object_X[*object_count];
					object_Y[i] = object_Y[*object_count];
					object_NUM[i] = object_NUM[*object_count];
					message_NUM[i] = message_NUM[*object_count];
					object_COLOR[i] = object_COLOR[*object_count];
					object_TYPE[i] = object_TYPE[*object_count];
					i = -1;
					*status = STATUS_SELECTED;
				}
			}
		}
		else 
		AddStuff(mouse_x, mouse_y, status, object_count, object_type, 
			object_num, message_num, object_color, object_x, object_y);
	}
}

void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type, int *object_num, 
				  int *message_num, int *object_color, int *last_button, int *sky)
{
	*last_button = (GP142_YMAX - y) / BUTTON_HEIGHT;
	switch(*last_button) 
	{
		case 0:		/* Change the background color */
			*background_color = (*background_color + 1) % MAX_COLORS;
			break;
		case 1:		/* Change the object color	*/
			if (object_type == OBJECT_SHAPE || object_type == OBJECT_MESSAGE)
				*object_color = (*object_color + 1) % MAX_COLORS;
			break;
		case 2:		/* Change the type of the currently selected object */
			if (object_type == OBJECT_SHAPE)
				*object_num = (*object_num + 1) % MAX_SHAPES;
			else if (object_type == OBJECT_MESSAGE)
				*message_num = (*message_num + 1) % MAX_MESSAGE;
			break;
		case 3:		/* Add message	*/		
			if(*status == STATUS_OBJECT || *status == STATUS_SELECTED)
			{
				*object_count = *object_count + 1;
				*status = STATUS_MESSAGE;	
			}
			else if(*status == STATUS_ADD_SHAPE)
				*status = STATUS_MESSAGE;
			break;
		case 4:		/* Add shape	*/
			if(*status == STATUS_OBJECT || *status == STATUS_SELECTED)
			{
				*object_count = *object_count + 1;
				*status = STATUS_ADD_SHAPE;		
			}
			else if(*status == STATUS_MESSAGE)
				*status = STATUS_ADD_SHAPE;
			break;
		case 5:		/* Select object	*/
			if(*status == STATUS_MESSAGE || *status == STATUS_ADD_SHAPE)
				*object_count = *object_count - 1;
			*status = STATUS_OBJECT;
			break;
		case 6:
			if(*sky == FALSE)
				*sky = TRUE;
			else
				*sky = FALSE;
			break;
		case 7:
			*object_count = -1;
			*status = STATUS_SELECTED;
			break;
		default:
			*status = 999;
			break;
	}
}

void AddStuff(int x, int y, int *status, int *object_count, int *object_type, 
			  int *object_num, int *message_num, int *object_color, 
			  int *object_x, int *object_y)
{
	if(*status == STATUS_ADD_SHAPE)
	{
		*object_num = SHAPE_DORA;
		*object_color = RED;
		*message_num = JUNK;
		*object_type = OBJECT_SHAPE;
	}
	else if (*status == STATUS_MESSAGE)
	{
		*object_num = JUNK;
		*object_color = BLUE;
		*message_num = MESSAGE1;
		*object_type = OBJECT_MESSAGE;
	}
	*object_x = x;
	*object_y = y;
	*status = STATUS_SELECTED;
}
